import java.util.*;

public class Arraz {


    int sumValuesOfArray(int[] intArray) {
        int sum = 0;
        for (int i : intArray) { sum += i; }
        return sum;
    }

    Double sumDoublesOfArray(Double[] doubleArray) {
        Double sum = 0.0;
        for (Double d : doubleArray) { sum += d; }
        return sum;
    }

    int averageOfArray(int[] intArray) {
        int sum = sumValuesOfArray(intArray);
        return sum/intArray.length;
    }

    Double doubleAverageOfArray(Double[] doubleArray) {
        Double sum = sumDoublesOfArray(doubleArray);
        return sum/doubleArray.length;
    }

    boolean containsValue(int[] intArray, int value) {
        for (int i = 0; i < intArray.length; i++) {
            if (intArray[i] == value) return true;
        }
        return false;
    }

    int[] reverseArray(int[] intArray) {
        for (int i = 0; i < intArray.length/2; i++) {
            int temp = intArray[i];
            intArray[i] = intArray[intArray.length-1-i];
            intArray[intArray.length-1-i] = temp;
        }
        return intArray;
    }

    OddEven oddEven(int[] intArray) {
        ArrayList<Integer> odds = new ArrayList<>();
        ArrayList<Integer> evens = new ArrayList<>();
        for (int i : intArray) {
            if (i%2==0) {
                evens.add(i);
            } else {
                odds.add(i);
            }
        }
        Integer[] oddsArray = odds.toArray(new Integer[odds.size()]);
        Integer[] evensArray = evens.toArray(new Integer[evens.size()]);
        return new OddEven(oddsArray, evensArray);
    }

    int findIndexOf(int[] intArray, int value) {
        for (int i = 0; i < intArray.length; i++) { if (intArray[i] == value) return i; }
        return -1;
    }

    Integer[] copyArrayByIterator(Integer[] intArray) {
        Iterator<Integer> integerIterator = Arrays.asList(intArray).iterator();
        Integer[] intArrayCopy = new Integer[intArray.length];
        int counter = 0;
        while (integerIterator.hasNext()) {
            intArrayCopy[counter] = integerIterator.next();
            counter++;
        }
        return intArrayCopy;
    }

    int[] copyArrayByLoop(int[] intArray) {
        int[] intArrayCopy = new int[intArray.length];
        for (int i = 0; i < intArray.length; i++) {
            intArrayCopy[i] = intArray[i];
        }
        return intArrayCopy;
    }

    int[] removeElementFromArray(int[] intArray, int value) {
        int[] newArray = new int[intArray.length-1];
        int counter = 0;
        for (int i: intArray) {
            if (i != value) {
                newArray[counter] = i;
                counter++;
            }
        }
        return newArray;
    }

    int[] insertIntoArrayAt(int[] intArray, int value, int index) {
        int[] newArray = new int[intArray.length+1];
        for (int i = 0; i < newArray.length; i++) {
            if (i < index) {
                newArray[i] = intArray[i];
            } else if (i == index) {
                newArray[i] = value;
            } else {
                newArray[i] = intArray[i-1];
            }
        }
        return newArray;
    }

    MaxMin findMaxMinOfArray(int[] intArray) {
        int max = Integer.MIN_VALUE;
        int min = Integer.MAX_VALUE;
        for (int i : intArray) {
            if (i > max) { max = i; }
            if (i < min) { min = i; }
        }
        return new MaxMin(max, min);
    }

    Integer[] removeDupesFromArray(Integer[] intArray) {
        ArrayList<Integer> integerArrayList = new ArrayList<>();
        for (Integer i : intArray) {
            if (!integerArrayList.contains(i)) {
                integerArrayList.add(i);
            }
        }
        return integerArrayList.toArray(new Integer[0]);
    }

    Double find2ndLargestValueFromArray(Double[] doubleArray){
        Arrays.sort(doubleArray);
        return doubleArray[doubleArray.length-2];
    }

    ArrayList<Integer> makeMeAnArrayListFromArray(Integer[] intArray) {
        return new ArrayList<>(Arrays.asList(intArray));
    }

    Integer[] makeMeAnArrayFromArrayList(ArrayList<Integer> integerArrayList) {
        return integerArrayList.toArray(new Integer[0]);
    }

    boolean check2ArraysForEqual(int[] intArray1, int[] intArray2) {
        return Arrays.equals(intArray1,intArray2);
    }

    int averageArrayWithoutMaxMin(int[] intArray) {
        MaxMin maxMin = findMaxMinOfArray(intArray);

        int[] intArrayUnmaxed = removeElementFromArray(intArray, maxMin.getMax());
        int[] intArrayUnmaxmined = removeElementFromArray(intArrayUnmaxed, maxMin.getMin());

        System.out.println(sumValuesOfArray(intArrayUnmaxmined));

        return averageOfArray(intArrayUnmaxmined);
    }

    boolean arrayHas65And77(int[] intArray) {
        return containsValue(intArray,65) && containsValue(intArray, 77);
    }

    boolean theTotalOfTensIs30(int[] intArray) {
        int sum = 0;
        for (int i : intArray) {
            if (i == 10) {
                sum += i;
            }
        }
        return sum == 30;
    }

    int[] findSmallestAndSecondSmallest(int[] intArray) {
        Arrays.sort(intArray);
        return new int[]{intArray[0],intArray[1]};
    }

    int[] makeMeAReverseCopyPlease(int[] intArray) {
        return Arrays.copyOf(reverseArray(intArray), intArray.length);
    }

    int[] removeLastItemAndCopy(int[] intArray) {
        return Arrays.copyOf(intArray, intArray.length-1);
    }

    int[] removeFirstItemAndCopy(int[] intArray) {
        return Arrays.copyOfRange(intArray,1,intArray.length);
    }

    int[] insertAtStartAndCopy(int[] intArray, int value) {
        return insertIntoArrayAt(intArray,value,0);
    }

    int[] insertAtEndAndCopy(int[] intArray, int value) {
        return insertIntoArrayAt(intArray,value,intArray.length);
    }

    int[] sortArrayIntoEvensThenOdds(int[] intArray) {
        int[] sortedArray = new int[intArray.length];
        int counter = 0;
        for (int i : intArray) { if (i%2==0) {
                sortedArray[counter] = i;
                counter++;
            } }
        for (int i : intArray) { if (i%2!=0) {
                sortedArray[counter] = i;
                counter++;
            } }
        return sortedArray;
    }

}
