import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;

import static org.junit.Assert.*;

public class ArrazTest {

    private int[] spiffyHandyIntArray;
    private Integer[] spiffyHandyIntegerArray;
    private Double[] spiffyHandyDoubleArray;
    private Arraz arraz;

    @Before
    public void before() {
        spiffyHandyIntArray = new int[] {4,5,102,6,-7,12,-32,92,8};
        spiffyHandyIntegerArray = new Integer[] {4,5,102,6,-7,12,-32,92,8};
        spiffyHandyDoubleArray = new Double[] {1.0, 0.5, 3.6, 38.4, 17.3, 62.0, 9.0, 3.375, 0.0, 3.14159};
        arraz = new Arraz();
    }

    @Test
    public void sumValuesOfArray() {
        int actual = arraz.sumValuesOfArray(spiffyHandyIntArray);
        int expected = 190;

        assertEquals(expected, actual);
    }

    @Test
    public void sumValuesOfArray2() {
        int actual = arraz.sumValuesOfArray(spiffyHandyIntArray);
        int expected = 191;

        assertNotEquals(expected, actual);
    }

    @Test
    public void sumDoublessOfArray() {
        Double actual = arraz.sumDoublesOfArray(spiffyHandyDoubleArray);
        double expected = 138.31659;

        assertEquals(expected, actual, 100);
    }

    @Test
    public void sumDoublessOfArray2() {
        double actual = arraz.sumDoublesOfArray(spiffyHandyDoubleArray);
        double expected = 139.0;

        assertNotEquals(expected, actual, 0.0);
    }

    @Test
    public void averageOfArray() {
        int actual = arraz.averageOfArray(spiffyHandyIntArray);
        int expected = 190/spiffyHandyIntArray.length;

        assertEquals(expected, actual);
    }

    @Test
    public void averageOfArray2() {
        int actual = arraz.averageOfArray(spiffyHandyIntArray);
        int expected = 190/spiffyHandyDoubleArray.length;

        assertNotEquals(expected, actual);
    }

    @Test
    public void doubleAverageOfArray() {
        double actual = arraz.doubleAverageOfArray(spiffyHandyDoubleArray);
        double expected = 138.31659/spiffyHandyDoubleArray.length;

        assertEquals(expected,actual,100);
    }

    @Test
    public void doubleAverageOfArray2() {
        double actual = arraz.doubleAverageOfArray(spiffyHandyDoubleArray);
        double expected = 137/spiffyHandyDoubleArray.length;

        assertEquals(expected,actual,100);
    }

    @Test
    public void containsValue() {
        assertTrue(arraz.containsValue(spiffyHandyIntArray, 4));
    }

    @Test
    public void containsValue2() {
        assertFalse(arraz.containsValue(spiffyHandyIntArray, 69));
    }

    @Test
    public void reverseArray() {
        int[] expected = new int[] {8,92,-32,12,-7,6,102,5,4};
        int[] actual = arraz.reverseArray(spiffyHandyIntArray);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void reverseArray2() {
        int[] actual = arraz.reverseArray(spiffyHandyIntArray);

        assertSame(spiffyHandyIntArray,actual);
    }

    @Test
    public void oddEven() {
        OddEven expected = new OddEven(new Integer[]{5,-7},new Integer[]{4,102,6,12,-32,92,8});
        OddEven actual = arraz.oddEven(spiffyHandyIntArray);


        assertArrayEquals(expected.getEvens(), actual.getEvens());
        assertArrayEquals(expected.getOdds(), actual.getOdds());
    }

    @Test
    public void oddEven2() {
        OddEven expected = new OddEven(new Integer[]{6,102,4,8,92,-32,12}, new Integer[]{-7,5});
        OddEven actual = arraz.oddEven(spiffyHandyIntArray);

        assertNotEquals(expected, actual);
    }

    @Test
    public void findIndexOf() {
        int expected = 2;
        int actual = arraz.findIndexOf(spiffyHandyIntArray, 102);

        assertEquals(expected, actual);
    }

    @Test
    public void findIndexOf2() {
        int expected = 3;
        int actual = arraz.findIndexOf(spiffyHandyIntArray, 102);

        assertNotEquals(expected, actual);
    }

    @Test
    public void copyArrayByIterator() {
        Integer[] actual = arraz.copyArrayByIterator(spiffyHandyIntegerArray);
        Integer[] expected = spiffyHandyIntegerArray;

        assertArrayEquals(expected,actual);
    }

    @Test
    public void copyArrayByIterator2() {
        Integer[] actual = arraz.copyArrayByIterator(spiffyHandyIntegerArray);

        assertNotNull(actual);
    }

    @Test
    public void copyArrayByLoop() {
        int[] actual = arraz.copyArrayByLoop(spiffyHandyIntArray);
        int[] expected = spiffyHandyIntArray;

        assertArrayEquals(expected,actual);
    }

    @Test
    public void copyArrayByLoop2() {
        int[] actual = arraz.copyArrayByLoop(spiffyHandyIntArray);

        assertNotNull(actual);
    }

    @Test
    public void removeElementFromArray() {
        int[] actual = arraz.removeElementFromArray(spiffyHandyIntArray, 102);
        int[] expected = new int[] {4, 5, 6, -7, 12, -32, 92, 8};

        assertArrayEquals(expected,actual);
    }

    @Test
    public void removeElementFromArray2() {
        int[] actual = arraz.removeElementFromArray(spiffyHandyIntArray, -32);
        int[] expected = new int[] {4, 5, 102, 6, -7, 12, 92, 8};

        assertArrayEquals(expected,actual);
    }

    @Test
    public void insertIntoArrayAt() {
        int[] actual = arraz.insertIntoArrayAt(spiffyHandyIntArray, 102, 3);
        int[] expected = new int[] {4, 5, 102, 102, 6, -7, 12, -32, 92, 8};

        assertArrayEquals(expected,actual);
    }

    @Test
    public void insertIntoArrayAt2() {
        int[] actual = arraz.insertIntoArrayAt(spiffyHandyIntArray, 102, 6);
        int[] expected = new int[] {4, 5, 102, 6, -7, 12, 102, -32, 92, 8};

        assertArrayEquals(expected,actual);
    }

    @Test
    public void findMaxMinOfArray() {
        MaxMin expected = new MaxMin();
        expected.setMax(102);
        expected.setMin(-32);
        MaxMin actual = arraz.findMaxMinOfArray(spiffyHandyIntArray);

        assertEquals(expected.getMax(),actual.getMax());
        assertEquals(expected.getMin(),actual.getMin());

    }

    @Test
    public void findMaxMinOfArray2() {
        MaxMin actual = arraz.findMaxMinOfArray(spiffyHandyIntArray);
        assertNotNull(actual);
    }

    @Test
    public void removeDupesFromArray() {
        Integer[] given = new Integer[] {4,4,5,102,6,6,-7,-7,12,-32,92,8,8};

        Integer[] actual = arraz.removeDupesFromArray(given);
        Integer[] expected = new Integer[] {4,5,102,6,-7,12,-32,92,8};

        assertArrayEquals(expected,actual);
    }

    @Test
    public void removeDupesFromArray2() {
        Integer[] given = new Integer[] {4,4,5,102,6,6,-7,-7,12,-32,92,8,8};
        Integer[] actual = arraz.removeDupesFromArray(given);

        assertFalse(Arrays.equals(given,actual));
    }

    @Test
    public void find2ndLargestValueFromArray() {
        double actual = arraz.find2ndLargestValueFromArray(spiffyHandyDoubleArray);
        double expected = 38.4;

        assertEquals(expected, actual, 0.0);
    }

    @Test
    public void find2ndLargestValueFromArray2() {
        double actual = arraz.find2ndLargestValueFromArray(spiffyHandyDoubleArray);
        double expected = 62.0;

        assertNotEquals(expected, actual, 0.0);
    }

    @Test
    public void makeMeAnArrayListFromArray() {
        ArrayList<Integer> actual = arraz.makeMeAnArrayListFromArray(spiffyHandyIntegerArray);
        ArrayList<Integer> expected = new ArrayList<Integer>(Arrays.asList(4,5,102,6,-7,12,-32,92,8));

        assertEquals(expected,actual);
    }

    @Test
    public void makeMeAnArrayListFromArray2() {
        ArrayList<Integer> actual = arraz.makeMeAnArrayListFromArray(spiffyHandyIntegerArray);

        assertNotNull(actual);
    }

    @Test
    public void makeMeAnArrayFromArrayList() {
        Integer[] actual = arraz.makeMeAnArrayFromArrayList(new ArrayList<>(Arrays.asList(4,5,102,6,-7,12,-32,92,8)));
        Integer[] expected = new Integer[] {4,5,102,6,-7,12,-32,92,8};

        assertArrayEquals(expected,actual);
    }

    @Test
    public void makeMeAnArrayFromArrayList2() {
        Integer[] actual = arraz.makeMeAnArrayFromArrayList(new ArrayList<>(Arrays.asList(4,5,102,6,-7,12,-32,92,8)));

        assertNotNull(actual);
    }

    @Test
    public void check2ArraysForEqual() {
        int[] int1 = new int[] {4,5,102,6,-7,12,-32,92,8};
        int[] int2 = new int[] {4,5,102,6,-7,12,-32,92,8};

        assertTrue(arraz.check2ArraysForEqual(int1,int2));
    }

    @Test
    public void check2ArraysForEqual2() {
        int[] int1 = new int[] {5,102,6,-7,12,-32,92,8};
        int[] int2 = new int[] {4,5,102,6,-7,12,-32,92};

        assertFalse(arraz.check2ArraysForEqual(int1,int2));
    }

    @Test
    public void averageArrayWithoutMaxMin() {
        int actual = arraz.averageArrayWithoutMaxMin(spiffyHandyIntArray);
        int expected = 120/(spiffyHandyIntArray.length-2);

        assertEquals(expected,actual);
    }

    @Test
    public void averageArrayWithoutMaxMin2() {
        int actual = arraz.averageArrayWithoutMaxMin(spiffyHandyIntArray);
        int expected = 120/spiffyHandyIntArray.length;

        assertTrue(expected!=actual);
    }

    @Test
    public void arrayHas65And77() {
        assertFalse(arraz.arrayHas65And77(spiffyHandyIntArray));
    }

    @Test
    public void arrayHas65And77b() {
        assertTrue(arraz.arrayHas65And77(new int[] {65, 77}));
    }

    @Test
    public void theTotalofTensIs30() {
        assertFalse(arraz.theTotalOfTensIs30(new int[] {10,10,10,10}));
    }

    @Test
    public void theTotalofTensIs30b() {
        assertTrue(arraz.theTotalOfTensIs30(new int[] {10,10,10}));

    }

    @Test
    public void findSmallestAndSecondSmallest() {
        int[] actual = arraz.findSmallestAndSecondSmallest(spiffyHandyIntArray);
        int[] expected = new int[] {-32,-7};

        assertArrayEquals(expected,actual);
    }

    @Test
    public void findSmallestAndSecondSmallest2() {
        int[] actual = arraz.findSmallestAndSecondSmallest(spiffyHandyIntArray);

        assertEquals(2, actual.length);
    }

    @Test
    public void makeMeAReverseCopyPlease() {
        int[] expected = new int[] {8,92,-32,12,-7,6,102,5,4};
        int[] actual = arraz.makeMeAReverseCopyPlease(spiffyHandyIntArray);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void makeMeAReverseCopyPlease2() {
        int[] actual = arraz.makeMeAReverseCopyPlease(spiffyHandyIntArray);

        assertNotSame(spiffyHandyIntArray,actual);
    }

    @Test
    public void removeLastItemAndCopy() {
        int[] expected = new int[] {4,5,102,6,-7,12,-32,92};
        int[] actual = arraz.removeLastItemAndCopy(spiffyHandyIntArray);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void removeLastItemAndCopy2() {
        int[] actual = arraz.removeLastItemAndCopy(spiffyHandyIntArray);

        assertNotSame(spiffyHandyIntArray, actual);
    }

    @Test
    public void removeFirstItemAndCopy() {
        int[] expected = new int[] {5,102,6,-7,12,-32,92,8};
        int[] actual = arraz.removeFirstItemAndCopy(spiffyHandyIntArray);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void removeFirstItemAndCopy2() {
        int[] actual = arraz.removeFirstItemAndCopy(spiffyHandyIntArray);

        assertNotSame(spiffyHandyIntArray, actual);
    }

    @Test
    public void insertAtStartAndCopy() {
        int[] expected = new int[] {1, 4,5,102,6,-7,12,-32,92,8};
        int[] actual = arraz.insertAtStartAndCopy(spiffyHandyIntArray, 1);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void insertAtStartAndCopy2() {
        int[] actual = arraz.insertAtStartAndCopy(spiffyHandyIntArray, 1);

        assertNotSame(spiffyHandyIntArray, actual);
    }

    @Test
    public void insertAtEndAndCopy() {
        int[] expected = new int[] {4,5,102,6,-7,12,-32,92,8, 1};
        int[] actual = arraz.insertAtEndAndCopy(spiffyHandyIntArray, 1);

        assertArrayEquals(expected, actual);
    }

    @Test
    public void insertAtEndAndCopy2() {
        int[] actual = arraz.insertAtEndAndCopy(spiffyHandyIntArray, 1);

        assertNotSame(spiffyHandyIntArray, actual);
    }

    @Test
    public void sortArrayIntoEvensThenOdds() {
        int[] expected = new int[] {4,102,6,12,-32,92,8,5,-7};
        int[] actual = arraz.sortArrayIntoEvensThenOdds(spiffyHandyIntArray);

        assertArrayEquals(expected,actual);
    }

    @Test
    public void sortArrayIntoEvensThenOdds2() {
        int[] expected = new int[] {4,5,102,6,-7,12,-32,92,8};
        int[] actual = arraz.sortArrayIntoEvensThenOdds(spiffyHandyIntArray);

        assertFalse(Arrays.equals(expected, actual));
    }

}